# coding: utf-8

"""
    LUXSCI

    For a technical overview, see [LuxSci API Mechanics Guide](/rest-api/mechanics.html)  Return to [The API Guide](/rest-api.html)  # noqa: E501

    OpenAPI spec version: v2023.12.4
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from luxsci.api_client import ApiClient
import hmac
import hashlib
import math
import datetime



class AuthenticationApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def authentication(self, **kwargs):  # noqa: E501
        """authentication  # noqa: E501

        In order to use any API commands, at any level, your client must first authenticate and obtain an authentication code. This authentication code can then be used to make one or more calls to API functions.    our authentication \"session\" can also be revoked, immediately invalidating all authentication codes received for it (i.e., this is a \"log out\").   In order to authenticate, you will need your API Token, API Key, and your API Host name. This API request is different from authenticated request in that you do not need to send a cookie, and the way that the request is signed is different.  See also [Authentication](/rest-api/mechanics.html#auth).  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.authentication(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param AuthBody body:
        :return: InlineResponse201
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if "secret" in kwargs and "token" in kwargs:
            secret = kwargs["secret"]
            token = kwargs["token"]
            date = str(math.floor(datetime.datetime.now().timestamp()))
            text_to_sign = token + "\n" + date + "\n" + (kwargs["username"] + "\n" + kwargs["password"] + "\n" if "username" in kwargs and "password" in kwargs else "" )
            signature = hmac.new(
                secret.encode(),
                msg=text_to_sign.encode(),
                digestmod=hashlib.sha256
            ).hexdigest().upper()
            kwargs["body"] = {
                "token": token,
                "date": date,
                "signature": signature
            }
        args = ["secret", "token", "username", "password"]
        store = {}
        for arg in args:
            store[arg] = kwargs.pop(arg, None)

        if kwargs.get('async_req'):
            to_return = self.authentication_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.authentication_with_http_info(**kwargs)  # noqa: E501
            to_return = data

        self.api_client.private_token = store["secret"]
        self.api_client.public_token = store["token"]
        self.api_client.username = store["username"]
        self.api_client.password = store["password"]
        return to_return

    def authentication_with_http_info(self, **kwargs):  # noqa: E501
        """authentication  # noqa: E501

        In order to use any API commands, at any level, your client must first authenticate and obtain an authentication code. This authentication code can then be used to make one or more calls to API functions.    our authentication \"session\" can also be revoked, immediately invalidating all authentication codes received for it (i.e., this is a \"log out\").   In order to authenticate, you will need your API Token, API Key, and your API Host name. This API request is different from authenticated request in that you do not need to send a cookie, and the way that the request is signed is different.  See also [Authentication](/rest-api/mechanics.html#auth).  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.authentication_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param AuthBody body:
        :return: InlineResponse201
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method authentication" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/auth', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse201',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def revoke_authentication(self, cookie, **kwargs):  # noqa: E501
        """revoke_authentication  # noqa: E501

        Revoke your authentication session and invalidate all authorization codes received. See also [Revocation](/rest-api/mechanics.html#revoke).  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.revoke_authentication(cookie, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cookie: (required)
        :return: InlineResponse200
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.revoke_authentication_with_http_info(cookie, **kwargs)  # noqa: E501
        else:
            (data) = self.revoke_authentication_with_http_info(cookie, **kwargs)  # noqa: E501
            return data

    def revoke_authentication_with_http_info(self, cookie, **kwargs):  # noqa: E501
        """revoke_authentication  # noqa: E501

        Revoke your authentication session and invalidate all authorization codes received. See also [Revocation](/rest-api/mechanics.html#revoke).  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.revoke_authentication_with_http_info(cookie, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cookie: (required)
        :return: InlineResponse200
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['cookie']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method revoke_authentication" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'cookie' is set
        if ('cookie' not in params or
                params['cookie'] is None):
            raise ValueError("Missing the required parameter `cookie` when calling `revoke_authentication`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}
        if 'cookie' in params:
            header_params['Cookie'] = params['cookie']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/auth', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse200',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
