# coding: utf-8

"""
    LUXSCI

    For a technical overview, see [LuxSci API Mechanics Guide](/rest-api/mechanics.html)  Return to [The API Guide](/rest-api.html)  # noqa: E501

    OpenAPI spec version: v2024.2.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class ContentTag(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'code_word': 'str',
        'title': 'str',
        'body_html': 'str',
        'body_text': 'str',
        'is_private': 'int',
        'format': 'str'
    }

    attribute_map = {
        'code_word': 'code_word',
        'title': 'title',
        'body_html': 'body_html',
        'body_text': 'body_text',
        'is_private': 'is_private',
        'format': 'format'
    }

    def __init__(self, code_word=None, title=None, body_html=None, body_text=None, is_private=None, format=None):  # noqa: E501
        """ContentTag - a model defined in Swagger"""  # noqa: E501
        self._code_word = None
        self._title = None
        self._body_html = None
        self._body_text = None
        self._is_private = None
        self._format = None
        self.discriminator = None
        self.code_word = code_word
        self.title = title
        if body_html is not None:
            self.body_html = body_html
        if body_text is not None:
            self.body_text = body_text
        if is_private is not None:
            self.is_private = is_private
        self.format = format

    @property
    def code_word(self):
        """Gets the code_word of this ContentTag.  # noqa: E501

        Textual unique content tag reference. Can contain only letters, numbers, and underscore characters. Cannot be a number. Must be unique across content tags in your account. Required.  # noqa: E501

        :return: The code_word of this ContentTag.  # noqa: E501
        :rtype: str
        """
        return self._code_word

    @code_word.setter
    def code_word(self, code_word):
        """Sets the code_word of this ContentTag.

        Textual unique content tag reference. Can contain only letters, numbers, and underscore characters. Cannot be a number. Must be unique across content tags in your account. Required.  # noqa: E501

        :param code_word: The code_word of this ContentTag.  # noqa: E501
        :type: str
        """
        if code_word is None:
            raise ValueError("Invalid value for `code_word`, must not be `None`")  # noqa: E501

        self._code_word = code_word

    @property
    def title(self):
        """Gets the title of this ContentTag.  # noqa: E501

        Internal title for this template.  # noqa: E501

        :return: The title of this ContentTag.  # noqa: E501
        :rtype: str
        """
        return self._title

    @title.setter
    def title(self, title):
        """Sets the title of this ContentTag.

        Internal title for this template.  # noqa: E501

        :param title: The title of this ContentTag.  # noqa: E501
        :type: str
        """
        if title is None:
            raise ValueError("Invalid value for `title`, must not be `None`")  # noqa: E501

        self._title = title

    @property
    def body_html(self):
        """Gets the body_html of this ContentTag.  # noqa: E501

        HTML content. Required for formats of “html” and “both”. This field can contain dynamic placeholders.  # noqa: E501

        :return: The body_html of this ContentTag.  # noqa: E501
        :rtype: str
        """
        return self._body_html

    @body_html.setter
    def body_html(self, body_html):
        """Sets the body_html of this ContentTag.

        HTML content. Required for formats of “html” and “both”. This field can contain dynamic placeholders.  # noqa: E501

        :param body_html: The body_html of this ContentTag.  # noqa: E501
        :type: str
        """

        self._body_html = body_html

    @property
    def body_text(self):
        """Gets the body_text of this ContentTag.  # noqa: E501

        Text content. Required for formats of “text” and “both”. This field can contain dynamic placeholders.  # noqa: E501

        :return: The body_text of this ContentTag.  # noqa: E501
        :rtype: str
        """
        return self._body_text

    @body_text.setter
    def body_text(self, body_text):
        """Sets the body_text of this ContentTag.

        Text content. Required for formats of “text” and “both”. This field can contain dynamic placeholders.  # noqa: E501

        :param body_text: The body_text of this ContentTag.  # noqa: E501
        :type: str
        """

        self._body_text = body_text

    @property
    def is_private(self):
        """Gets the is_private of this ContentTag.  # noqa: E501

        When set to 1, the template is private and will not be shared with other users.  When set to 0, the default, the template may be shared.  # noqa: E501

        :return: The is_private of this ContentTag.  # noqa: E501
        :rtype: int
        """
        return self._is_private

    @is_private.setter
    def is_private(self, is_private):
        """Sets the is_private of this ContentTag.

        When set to 1, the template is private and will not be shared with other users.  When set to 0, the default, the template may be shared.  # noqa: E501

        :param is_private: The is_private of this ContentTag.  # noqa: E501
        :type: int
        """

        self._is_private = is_private

    @property
    def format(self):
        """Gets the format of this ContentTag.  # noqa: E501

        Required. What content formats to support? One of these values must be supplied: (html|text|both).  # noqa: E501

        :return: The format of this ContentTag.  # noqa: E501
        :rtype: str
        """
        return self._format

    @format.setter
    def format(self, format):
        """Sets the format of this ContentTag.

        Required. What content formats to support? One of these values must be supplied: (html|text|both).  # noqa: E501

        :param format: The format of this ContentTag.  # noqa: E501
        :type: str
        """
        if format is None:
            raise ValueError("Invalid value for `format`, must not be `None`")  # noqa: E501

        self._format = format

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ContentTag, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ContentTag):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
